#include <stdio.h>
#include <time.h>
#include "nessie.h"

void NESSIEblank  (const struct NESSIEstruct * const structpointer,
		     const u8 *const plaintext,
		           u8 *const ciphertext)
{
int i;
for (i=0;i<16;i++)
    ciphertext[i]=plaintext[i];
}

int main ()
{
int i;
struct NESSIEstruct keys;
u8 blank[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
u8 input[16]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
u8 output[16];
time_t start,end;
unsigned t1,t2,t3;

NESSIEkeysetup(blank,&keys);

start=time(NULL);
for (i=0;i<1000000;i++)
    {
    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);

    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);
    NESSIEencrypt(&keys,input,input);
    }
end=time(NULL);
t1=end-start;
printf("%i\n",t1);

start=time(NULL);
for (i=0;i<1000000;i++)
    {
    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);

    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);
    NESSIEblank(&keys,input,input);
    }
end=time(NULL);
t2=end-start;
printf("%i\n",t2);
printf("%i\n",t1-t2);
getchar();
}
